unit PDJSillyTools;


// PDJSillyTools version 1.00
// Freeware Component for for D3,D4,D5,D6
// Copyright  2000-2001 by Peric
// Birthday of Component 30.08.2001
// E-mail: pericddn@ptt.yu
// If I' find any errors or rubbish in PDJSillyTools please send me Your suggest or Reclamation.


{$IFDEF VER90}
  {$DEFINE PDJ_D2}
{$ELSE}
{$IFDEF VER100}
  {$DEFINE PDJ_D3}
{$ELSE}
  {$IFDEF VER120}
    {$DEFINE PDJ_D4}
  {$ELSE}
    {$DEFINE PDJ_D5Up}
  {$ENDIF}
{$ENDIF}
{$ENDIF}

{$IFDEF VER140}
  {$DEFINE PDJ_D6}
{$ENDIF}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,ExtCtrls,MMSystem,StdCtrls;

 {$R PDJSillyTools.res}



type
  TAligment=(srRightJustify,srLeftJustify);
  TOnMouseOverEvent = procedure(Sender: TObject) of object;
  TOnMouseOutEvent = procedure(Sender: TObject) of object;

  TPDJSillyRadio = class(TCustomControl)

  private

    MainRect,
    CaptRect,
    TriangleRect,
    ECaptRect,
    Image:TRect;
    FAligment:TAligment;
    FGlyph:TBitmap;
    TransColor,
    FColorUnChecked,
    FColorChecked,
    FColorLine,
    FColorLineFocus,
    Kolorit:TColor;
    Index:integer;
    FChecked,
    FShowHand,
    FHotTrack,
    FTransparent:Boolean;
    FDonja:TPanel;
    FVersion,
    FHintTwo: string;
    {$IFDEF PDJ_D3}
        {$ELSE}
    BiDiFlags: Longint ;
        {$ENDIF}
    FOnMouseOver: TOnMouseOverEvent;
    FOnMouseOut: TOnMouseOutEvent;
    function  GetHintTwo: string;
    function GetVersion: string;
    procedure SetVersion(const Value: string);
    procedure SetHintTwo(AHintTwo: string);
    procedure DrawParentImage (Control: TControl; Dest: TCanvas);
    procedure SetShowHotHand(index: integer; value:boolean);
    procedure SetChecked (Value: Boolean);
    procedure SetColor(index: integer; value: TColor);
    procedure DrawCaption;
    procedure DrawTriangle;
    procedure DrawGlyph;
    procedure DrawCaptionEnabled;
    procedure SetAligment(value:TAligment);
    procedure DoKliknime(Sender: TObject);
    procedure CMMouseEnter(var AMsg: TMessage);
              message CM_MOUSEENTER;
    procedure CMMouseLeave(var AMsg: TMessage);
              message CM_MOUSELEAVE;
    procedure CmEnabledChanged(var Message: TWmNoParams);
              message CM_ENABLEDCHANGED;
    procedure CmParentColorChanged(var Message: TWMNoParams);
              message CM_PARENTCOLORCHANGED;
    procedure CmTextChanged(var Message: TWmNoParams);
              message CM_TEXTCHANGED;
    procedure CmVisibleChanged(var Message: TWmNoParams);
              message CM_VISIBLECHANGED;
    procedure CmParentFontChanged(var Message: TWMNoParams);
              message CM_FONTCHANGED;
    procedure WMLButtonDblClk (var Message: TWMLButtonDown);
              message WM_LBUTTONDBLCLK;
    procedure CNCommand (var Message: TWMCommand);
              message CN_COMMAND;
    procedure WMSetFocus(var Message: TWMSetFocus);
              message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus);
              message WM_KILLFOCUS;
    procedure CmDialogChar(var Message: TCMDialogChar);
              message CM_DIALOGCHAR;

  protected

    procedure Paint; override;
    procedure Click;override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure CreateWnd; override;
    procedure DoEnter; override;
    procedure DoExit; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;

  public

    constructor Create(aOwner: TComponent); override;
    destructor Destroy; override;

  published

    property HintSecondLine:string read GetHintTwo  write SetHintTwo;
    property Version: string read GetVersion write SetVersion;
    property Transparent:boolean index 3 read FTransparent
              write SetShowHotHand default False;
    property HotTrack:boolean index 1 read FHotTrack
             write SetShowHotHand default True;
    property OnMouseEnter: TOnMouseOverEvent read FOnMouseOver
             write FOnMouseOver;
    property OnMouseExit: TOnMouseOutEvent read FOnMouseOut
             write FOnMouseOut;
    property ShowHandCursor:boolean index 2 read FShowHand
             write SetShowHotHand default True;
    property Aligment:TAligment read FAligment write
             SetAligment default srRightJustify;
    property Caption;
    property Color;
    property Enabled;
    property DragCursor;
    property DragMode;
    property Font;
    property ParentFont;
    property ParentColor;
    property Visible;
    property ShowHint;
    property ColorUnChecked:TColor index 1 read FColorUnChecked
             write SetColor default clBtnHighlight;
    property ColorChecked:TColor index 2 read FColorChecked
             write SetColor default clBlue;
    property ColorLine:TColor index 3 read FColorLine
             write SetColor default clBtnHighlight;
    property ColorLineFocus:TColor index 4 read FColorLineFocus
             write SetColor default clBlue;
    property Checked: Boolean read FChecked write SetChecked default false;
    property OnClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnStartDrag;
    property OnEnter;
    property OnExit;
    property TabStop;
    property TabOrder;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseUp;
    property OnMouseMove;
    
    property PopUpMenu;
    {$IFDEF PDJ_D5Up}
    property OnContextPopup;
    {$ENDIF}
      {$IFDEF PDJ_D3}
  {$ELSE}
    property DragKind;
    property Anchors;
    property Constraints;
    property BiDiMode;
    property ParentBiDiMode;
    property OnStartDock;
    property OnEndDock;
  {$ENDIF}
  end;

//******************************************************************************

type

{TPDJSillyGroup}

  TStyleFrame = (sgRoundFrame,sgStandardFrame,sg3DRoundFrame);
  TCaptionAlign = (caLeft,caRight);
  TFrameRadius = 10..60;
  TPDJCustomSillyGroup = class(TCustomGroupBox)
  private

    FVersion,
    FHintTwo: string;
    FFrameRadius:TFrameRadius;
    FColorLineFrame,
    FColorCaption:TColor;
    FStyleFrame:TStyleFrame;
    FCaptionAlign:TCaptionAlign;
    FOnMouseOver: TOnMouseOverEvent;
    FOnMouseOut: TOnMouseOutEvent;
    FTransparent:boolean;
    function  GetHintTwo: string;
    function GetVersion: string;
    procedure SetTransparent(value: boolean);
    procedure DrawParentImage (Control: TControl; Dest: TCanvas);
    procedure SetVersion(const Value: string);
    procedure SetHintTwo(AHintTwo: string);
    procedure SetColor(index: integer; value: TColor);
    procedure SetFrameRadius(value:TFrameRadius);
    procedure SetStyleFrame(value:TStyleFrame);
    procedure SetCaptionAlign(value:TCaptionAlign);
    procedure CMMouseEnter(var AMsg: TMessage);
              message CM_MOUSEENTER;
    procedure CMMouseLeave(var AMsg: TMessage);
              message CM_MOUSELEAVE;

  protected

    procedure Paint;override;
    property HintSecondLine:string read GetHintTwo  write SetHintTwo;
    property Version: string read GetVersion write SetVersion;
    property CaptionAlign:TCaptionAlign read FCaptionAlign
                write SetCaptionAlign default caRight;
    property StyleFrame:TStyleFrame read FStyleFrame
                write SetStyleFrame default sgRoundFrame;
    property CaptionColor:TColor index 3 read FColorCaption
                write SetColor default clBtnface;
    property ColorLineFrame:TColor index 2 read FColorLineFrame
                write SetColor default clBtnShadow;
    property FrameRadius:TFrameRadius read FFrameRadius
                write SetFrameRadius default 30;
    property Transparent:boolean read FTransparent
                write SetTransparent default False;
    property OnMouseEnter: TOnMouseOverEvent read FOnMouseOver
             write FOnMouseOver;
    property OnMouseExit: TOnMouseOutEvent read FOnMouseOut
             write FOnMouseOut;
  public

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

TPDJSillyGroup = class(TPDJCustomSillyGroup)

  published

    property Transparent;
    property HintSecondLine;
    property Version;
    property CaptionAlign;
    property StyleFrame;
    property CaptionColor;
    property ColorLineFrame;
    property FrameRadius;
    property Align;
    property Caption;
    property Color;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnStartDrag;
    property OnMouseEnter;
    property OnMouseExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;

  {$IFDEF PDJ_D5Up}
    property OnContextPopup;
    {$ENDIF}
      {$IFDEF PDJ_D3}
  {$ELSE}
    property DockSite;
    property DragKind;
    property Anchors;
    property Constraints;
    property BiDiMode;
    property ParentBiDiMode;
    property OnStartDock;
    property OnEndDock;
    property OnGetSiteInfo;
    property OnUnDock;
  {$ENDIF}

  end;



type
 TPDJSillyRadioGroup = class(TPDJCustomSillyGroup)

  private

    FButtons: TList;
    FItems: TStrings;
    FItemIndex,
    FColumns: Integer;
    FReading,
    FUpdating,
    FTransparent,
    FMShowHandCursor: Boolean;
    FMColorChecked,
    FMColorUnChecked,
    FMColorLineFocus,
    FMColorLine:TColor;
    procedure SetShowHandCursor(Value: boolean);
    procedure SetTransparent(Value: boolean);
    procedure SetColor(index:integer ; Value: TColor);
    procedure ArrangeButtons;
    procedure ButtonClick(Sender: TObject);
    procedure ItemsChange(Sender: TObject);
    procedure SetButtonCount(Value: Integer);
    procedure SetColumns(Value: Integer);
    procedure SetItemIndex(Value: Integer);
    procedure SetItems(Value: TStrings);
    procedure UpdateButtons;
    procedure CMEnabledChanged(var Message: TMessage);
              message CM_ENABLEDCHANGED;
    procedure CMFontChanged(var Message: TMessage);
              message CM_FONTCHANGED;
    procedure WMSize(var Message: TWMSize);
              message WM_SIZE;

  protected

    procedure ReadState(Reader: TReader); override;
    function CanModify: Boolean; virtual;
    procedure GetChildren(Proc: TGetChildProc; Root: TComponent); override;

  public

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

  published

    property ShowHandCursor:boolean read FMShowHandCursor
                write SetShowHandCursor default True;
    property Columns: Integer read FColumns write SetColumns default 1;
    property ItemIndex: Integer read FItemIndex write SetItemIndex default -1;
    property Items: TStrings read FItems write SetItems;
    property HintSecondLine;
    property Version;
    property CaptionAlign;
    property StyleFrame;
    property CaptionColor;
    property ColorLineFrame;
    property FrameRadius;
    property Align;
    property Transparent:boolean read FTransparent
                write SetTransparent default False;
    property Caption;
    property Color;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnStartDrag;
    property ColorChecked:TColor index 1 read FMColorChecked
                write SetColor default clBlue;
    property ColorUnChecked:TColor index 2 read FMColorUnChecked
                write SetColor default clBtnHighlight;
    property ColorLineFocus:TColor index 4 read FMColorLineFocus
                write SetColor default clBlue;
    property ColorLine:TColor index 3 read FMColorLine
                write SetColor default clBtnHighlight;
    
  {$IFDEF PDJ_D5Up}
    property OnContextPopup;
    {$ENDIF}
      {$IFDEF PDJ_D3}
  {$ELSE}
    property DragKind;
    property Anchors;
    property Constraints;
    property BiDiMode;
    property ParentBiDiMode;
    property OnStartDock;
    property OnEndDock;
  {$ENDIF}

  end;

//******************************************************************************

{ TPDJsillyGroupButton }

type
  TPDJSillyGroupButton = class(TPDJSillyRadio)

  private

    FInClick: Boolean;
    procedure CNCommand(var Message: TWMCommand);
              message CN_COMMAND;

  protected

    procedure ChangeScale(M, D: Integer); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;

  public

    constructor InternalCreate(PDJSillyRadioGroup: TPDJSillyRadioGroup);
    destructor Destroy; override;

    published
    
  property ColorChecked;
  property ColorUnChecked;
  property ColorLineFocus;
  property ColorLine;
  property Transparent;
  property ShowHandCursor;

  end;
//******************************************************************************

procedure Register;
  
implementation

const
TriangleWidth=10;
TriangleHeight=9;


procedure Register;
begin
  RegisterComponents('PDJSillyTools', [TPDJSillyRadio,
  TPDJSillyGroup,TPDJSillyRadioGroup]);
end;

//******************************************************************************
{TPDJSillyRadio}


constructor TPDJSillyRadio.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
ControlStyle := ControlStyle + [csReplicatable];
SetBounds(0, 0, 97, 19);
FAligment:=srRightJustify;
FColorUnChecked :=clBtnHighlight;
FColorChecked:=clBlue;
FChecked:=False;
FGlyph := TBitmap.Create;
FGlyph.Width:=TriangleWidth;
FGlyph.Height:=TriangleHeight;
FColorLine:=clBtnHighlight;
FColorLineFocus:=clBlue;
FShowHand:=True;
FHotTrack:=True;
FTransparent:=False;
FVersion:='Version 1.00, Copyright  2000-2001 by Peric, E-mail: pericddn@ptt.yu';
  FDonja := TPanel.Create(Self);
  with FDonja do
  begin
  ControlStyle:= ControlStyle - [csAcceptsControls];
  Caption:=' ';
  BevelOuter:=bvNone;
  Align:=alBottom;
  Color:=FColorLine;
  Height:=1;
  end;
  InsertControl(FDonja);
end;

destructor TPDJSillyRadio.Destroy;
begin
FGlyph.free;
  inherited Destroy;
end;

function TPDJSillyRadio.GetHintTwo: string;
begin
     Result:=FHintTwo;
end;

procedure TPDJSillyRadio.SetHintTwo(AHintTwo:String);
begin
FHintTwo:=AHintTwo;
if csDesigning in ComponentState then
 Exit;
  if hint<>'' then
  if FHintTwo<>'' then
hint:=hint+#13+FHintTwo else
hint:=hint;
end;


procedure TPDJSillyRadio.SetVersion(const Value: string);
begin
  FVersion:=FVersion;
end;

function TPDJSillyRadio.GetVersion: string;
begin
  Result:=FVersion;
end;

procedure TPDJSillyRadio.DrawParentImage(Control: TControl; Dest: TCanvas);
var
  SaveIndex: Integer;
  DC: HDC;
  Position: TPoint;
begin
  with Control do
  begin
    if Parent = nil then
      Exit;
    DC := Dest.Handle;
    SaveIndex := SaveDC(DC);
    GetViewportOrgEx(DC, Position);
    SetViewportOrgEx(DC, Position.X - Left, Position.Y - Top, nil);
    IntersectClipRect(DC, 0, 0, Parent.ClientWidth, Parent.ClientHeight);
    Parent.Perform(WM_ERASEBKGND, DC, 0);
    Parent.Perform(WM_PAINT, DC, 0);
    RestoreDC(DC, SaveIndex);
  end;
end;

procedure TPDJSillyRadio.DoKliknime(Sender: TObject);
begin
 if assigned(OnClick) then OnClick(Self);
end;

procedure TPDJSillyRadio.CMDialogChar(var Message: TCMDialogChar);
begin
  with Message do
    if IsAccel(CharCode, Caption) and CanFocus then
    begin
      Click;
      Result := 1;
      SetFocus;
    SetChecked(True);
    end
    else
      inherited;
end;

procedure TPDJSillyRadio.WMSetFocus(var Message: TWMSetFocus);
begin
inherited;
FDonja.Color:=FColorLineFocus;
if FDonja.Color=FColorLineFocus then SetChecked(True);
Repaint;
end;

procedure TPDJSillyRadio.WMKillFocus(var Message: TWMKillFocus);
begin
inherited;
FDonja.Color:=FColorLine;
Repaint;
end;

procedure TPDJSillyRadio.DoEnter;
begin   
  inherited DoEnter;
  
end;

procedure TPDJSillyRadio.DoExit;
begin
  inherited DoExit;
end;

procedure TPDJSillyRadio.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then doKliknime(Self);
  inherited KeyDown(Key, Shift);
end;


procedure TPDJSillyRadio.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
Begin
if Button<>mbleft then exit else begin
if not enabled then exit;
SetFocus;
SetChecked (True);
end;
end;

procedure TPDJSillyRadio.CreateWnd;
begin
  inherited CreateWnd;
  SendMessage(Handle, BM_SETCHECK, Cardinal(FChecked), 0);
end;

procedure TPDJSillyRadio.CNCommand (var Message: TWMCommand);
begin
  if Message.NotifyCode = BN_CLICKED then Click;
end;

procedure TPDJSillyRadio.Click;
begin
inherited;
end;

procedure TPDJSillyRadio.WMLButtonDblClk (var Message: TWMLButtonDown);
begin
  inherited;
  Click;
end;

procedure TPDJSillyRadio.SetChecked (Value: Boolean);
var
  I: Integer;
  Sibling: TPDJSillyRadio;
begin
  if FChecked <> Value then
  begin
    TabStop := Value;
    FChecked := Value;
    if Value then
    begin
      if Parent <> nil then
        for i := 0 to Parent.ControlCount-1 do
          if Parent.Controls[i] is TPDJSillyRadio then
          begin
            Sibling := TPDJSillyRadio(Parent.Controls[i]);
            if (Sibling <> Self) then
              Sibling.SetChecked(False);
          end;
      Click;
      if csDesigning in ComponentState then
        if (GetParentForm(self) <> nil) and (GetParentForm(self).Designer <> nil) then
          GetParentForm(self).Designer.Modified;
    end;
    Repaint;
  end;
end;

procedure TPDJSillyRadio.SetShowHotHand(index: integer; value:boolean);
begin
Case index of
1:
if value<>FHotTrack then
FHotTrack:=value;
2:
if value<>FShowHand then
FShowHand:=value;
3:begin
if value<>FTransparent then
FTransparent:=value;
Repaint;
end;
end;
end;

procedure TPDJSillyRadio.SetColor(index: integer; value: TColor);
begin
Case index of
1:
if value<>FColorUnChecked then
FColorUnChecked:=value;
2:
if value<>FColorChecked then
FColorChecked:=value;
3:begin
if value<>FColorLine then
FColorLine:=value;
if enabled then begin
FDonja.Color:=FColorLine;
end;
end;
4:
if value<>FColorLineFocus then
FColorLineFocus:=value;
end;
Repaint;
end;

procedure TPDJSillyRadio.SetAligment(value:TAligment);
begin
if value<>FAligment then
FAligment:=value;
Repaint;
end;

procedure TPDJSillyRadio.Paint;
begin
MainRect:=ClientRect;
  if FTransparent then
    DrawParentImage(Self, Self.Canvas);
DrawCaption;
DrawGlyph;
end;

procedure TPDJSillyRadio.DrawGlyph;
begin
with FGlyph, canvas do
begin
Image := Rect(0, 0, 10, 9);
Brush.Color:=Color;
FillRect(Image);
 if enabled then begin
 if not FChecked then
Brush.Color:=FColorUnChecked else Brush.Color:=FColorChecked;
Pen.Color:=Brush.Color;
end
else
begin
Brush.Color:=Color;
Pen.Color:=clBtnShadow;
end;
Case FAligment of
srRightJustify:
Polygon([Point(0,0),
Point(0,TriangleWidth-1),
Point(TriangleWidth-1,TriangleHeight div 2)]);
srLeftJustify:
Polygon([Point(TriangleWidth-1,0),
Point(0,TriangleHeight div 2),
Point(TriangleWidth-1,TriangleHeight-1)]);
end;
end;
DrawTriangle;
end;


procedure TPDJSillyRadio.DrawTriangle;
var X:integer;
begin
with canvas do begin
x:=(MainRect.top+((MainRect.bottom-MainRect.top)-TriangleHeight) div 2);
Case FAligment of
srRightJustify:
TriangleRect := Rect(MainRect.Left+2, x , MainRect.Left+2+TriangleWidth, x+TriangleHeight);
srLeftJustify:
TriangleRect := Rect(MainRect.right-12, x , MainRect.right-12+Trianglewidth, x+Triangleheight);
end;
TransColor := FGlyph.Canvas.Pixels[3, FGlyph.Height - 1];
BrushCopy(TriangleRect, FGlyph,Image, TransColor);
end;
end;

procedure TPDJSillyRadio.CMMouseEnter(var AMsg: TMessage);
begin
if not enabled then exit;
if FHotTrack then begin
index:=1;
DrawCaption;
end;
IF FShowHand then begin
Screen.Cursors[1] := LoadCursor(hinstance,'SILLYHAND');
Cursor := 1;
end;
if Assigned(FOnMouseOver) then FOnMouseOver(Self);
end;

procedure TPDJSillyRadio.CMMouseLeave(var AMsg: TMessage);
begin
if not enabled then exit;
if FHotTrack then
begin
index:=0;
DrawCaption;
end;
IF FShowHand then begin
Screen.Cursors[0] := crDefault;
Cursor := 0;
end;
if Assigned(FOnMouseOut) then FOnMouseOut(Self);
end;

procedure TPDJSillyRadio.DrawCaption;
var
  x:integer;
begin
  with Canvas do
  begin
    Font := Self.Font;
    Kolorit:=Font.Color;

    if FHotTrack then
    if index=1 then
    Font.color:=clBlue else Font.color:= Kolorit;

    Brush.Style := bsClear;
    x:=(MainRect.top+((MainRect.bottom-MainRect.top)-TextHeight(Caption)) div 2);
    begin
    case FAligment of
    srRightJustify:CaptRect := Rect(MainRect.Left+18, x , MainRect.Left+18+TextWidth(Caption), x+TextHeight(Caption));
    srLeftJustify:CaptRect := Rect(MainRect.Left+2, x , MainRect.Left+2+TextWidth(Caption), x+TextHeight(Caption));
    end;
    if not Enabled then DrawCaptionEnabled;
           {$IFDEF PDJ_D3}
    DrawText(Handle, PChar(Caption), Length(Caption), CaptRect, DT_LEFT );
      {$ELSE}
    DrawText(Handle, PChar(Caption), Length(Caption), CaptRect, DT_LEFT or BiDiFlags );
      {$ENDIF}
  end;
  end;

  end;


procedure TPDJSillyRadio.DrawCaptionEnabled;
begin
with canvas do
  begin
     Font := Self.Font;
     brush.style:=bsClear;
                {$IFDEF PDJ_D3}
     DrawText(Handle, PChar(Caption), Length(Caption), CaptRect, DT_LEFT );
      {$ELSE}
      DrawText(Handle, PChar(Caption), Length(Caption), CaptRect, DT_LEFT or BiDiFlags );
       {$ENDIF}
     font.Color :=clBtnHighlight;
     ECaptRect:=Rect(CaptRect.Left+1,CaptRect.top+1,CaptRect.Right+1,CaptRect.Bottom+1);
       {$IFDEF PDJ_D3}
     DrawText(Handle, PChar(Caption), Length(Caption), ECaptRect, DT_LEFT );
        {$ELSE}
        DrawText(Handle, PChar(Caption), Length(Caption), ECaptRect, DT_LEFT or BiDiFlags );
        {$ENDIF}
     font.color :=clBtnShadow;
  end;
end;

procedure TPDJSillyRadio.CmParentFontChanged(var Message: TWMNoParams);
begin
  inherited;
  Invalidate;
end;

procedure TPDJSillyRadio.CmTextChanged(var Message: TWmNoParams);
begin
  inherited;
  Invalidate;
end;

procedure TPDJSillyRadio.CmVisibleChanged(var Message: TWmNoParams);
begin
  inherited;
  Invalidate;
end;

procedure TPDJSillyRadio.CmParentColorChanged(var Message: TWMNoParams);
begin
  inherited;
  Invalidate;
end;

procedure TPDJSillyRadio.CmEnabledChanged(var Message: TWmNoParams);
begin
  inherited;
  if enabled then
FDonja.Color:=FColorLine
else
FDonja.Color:=clBtnShadow;

  Invalidate;
end;

//******************************************************************************

constructor TPDJCustomSillyGroup.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
 FColorCaption:=clBtnface;
 FColorLineFrame:=clBtnShadow;
 FFrameRadius:=30;
 FStyleFrame:=sgRoundFrame;
 FCaptionAlign:=caRight;
 FVersion:='Version 1.00, Copyright  2000-2001 by Peric, E-mail: pericddn@ptt.yu';
 Ftransparent:=False;
end;

destructor TPDJCustomSillyGroup.Destroy;
begin
  inherited Destroy;
end;

procedure TPDJCustomSillyGroup.SetTransparent(value:boolean);
begin
if value<>FTransparent then
FTransparent:=value;
repaint;
end;

procedure TPDJCustomSillyGroup.Paint;
var
  H: Integer;
  R: TRect;
   {$IFDEF PDJ_D3}
  {$ELSE}
  Flags: Longint;
  {$ENDIF}
begin
  if FTransparent then
    DrawParentImage(Self, Self.Canvas);
    
  with Canvas do
  begin
    Font := Self.Font;
    H := TextHeight('0');
    R := Rect(0, H div 2 - 1, Width, Height);
    Case FStyleFrame of
    sgRoundFrame:
    begin
    
    Brush.Color:=Color;
    if FTransparent then Brush.Style:=bsClear;
    Pen.Color:=FColorLineFrame;
    Pen.Width:=1;
    RoundRect(R.Left+2, R.Top, R.Right-2, R.Bottom-2, FFrameRadius, FFrameRadius);
    end;
    sg3DRoundFrame:
    begin
    Brush.Style:=bsClear;
    Inc(R.Left);
    Inc(R.Top);
    Pen.Color:=clBtnHighlight;
    Pen.Width:=1;
    RoundRect(R.Left+2, R.Top, R.Right-2, R.Bottom-2, FFrameRadius, FFrameRadius);
    OffsetRect(R, -1, -1);
    Pen.Color:=clBtnShadow;
    RoundRect(R.Left+2, R.Top, R.Right-2, R.Bottom-2, FFrameRadius, FFrameRadius);
    end;
    sgStandardFrame:
    begin
    if FTransparent then Brush.Style:=bsClear;
      Inc(R.Left);
      Inc(R.Top);
      Brush.Color := clBtnHighlight;
      FrameRect(R);
      OffsetRect(R, -1, -1);
      Brush.Color := clBtnShadow;
    FrameRect(R);
    end;
    end;
    if Text <> '' then
    begin
    
    Case FCaptionAlign of

    caLeft:
        R := Rect(12+(FFrameRadius div 4), 0, 0, H);
    caRight:
        R := Rect(R.Right - Canvas.TextWidth(Text)-12-(FFrameRadius div 4), 0, 0, H);
    end;
    {$IFDEF PDJ_D3}
    DrawText(Handle, PChar(Text), Length(Text), R, DT_CALCRECT );
    {$ELSE}
      Flags := DrawTextBiDiModeFlags(DT_SINGLELINE);
      DrawText(Handle, PChar(Text), Length(Text), R, Flags or DT_CALCRECT);
      {$ENDIF}
     
      Brush.Color := FColorCaption;
      {$IFDEF PDJ_D3}
       DrawText(Handle, PChar(Text), Length(Text), R, DT_LEFT or DT_SINGLELINE);
      {$ELSE}
      DrawText(Handle, PChar(Text), Length(Text), R, Flags);
      {$ENDIF}
    end;
  end;
end;

procedure TPDJCustomSillyGroup.SetCaptionAlign(value:TCaptionAlign);
begin
if value<>FCaptionAlign then
FCaptionAlign:=value;
Repaint;
end;

procedure TPDJCustomSillyGroup.SetStyleFrame(value:TStyleFrame);
begin
if value<>FStyleFrame then
FStyleFrame:=value;
Repaint;
if FStyleFrame=sgStandardFrame then SetFrameRadius(10);

end;


procedure TPDJCustomSillyGroup.SetFrameRadius(value: TFrameRadius);
begin
if value<>FFrameRadius then
FFrameRadius:=value;
Repaint;
end;




procedure TPDJCustomSillyGroup.SetColor(index: integer; value: TColor);
begin
Case index of
2:
if value<>FColorLineFrame then
FColorLineFrame:=value;
3:
if value<>FColorCaption then
FColorCaption:=value;
end;
Repaint;
end;

procedure TPDJCustomSillyGroup.CMMouseEnter(var AMsg: TMessage);
begin
if Assigned(FOnMouseOver) then FOnMouseOver(Self);
end;

procedure TPDJCustomSillyGroup.CMMouseLeave(var AMsg: TMessage);
begin
if Assigned(FOnMouseOut) then FOnMouseOut(Self);
end;


function TPDJCustomSillyGroup.GetHintTwo: string;
begin
     Result:=FHintTwo;
end;

procedure TPDJCustomSillyGroup.SetHintTwo(AHintTwo:String);
begin
FHintTwo:=AHintTwo;
if csDesigning in ComponentState then
 Exit;
  if hint<>'' then
  if FHintTwo<>'' then
hint:=hint+#13+FHintTwo else
hint:=hint;
end;


procedure TPDJCustomSillyGroup.SetVersion(const Value: string);
begin
  FVersion:=FVersion;
end;

function TPDJCustomSillyGroup.GetVersion: string;
begin
  Result:=FVersion;
end;

procedure TPDJCustomSillyGroup.DrawParentImage(Control: TControl; Dest: TCanvas);
var
  SaveIndex: Integer;
  DC: HDC;
  Position: TPoint;
begin
  with Control do
  begin
    if Parent = nil then
      Exit;
    DC := Dest.Handle;
    SaveIndex := SaveDC(DC);
    GetViewportOrgEx(DC, Position);
    SetViewportOrgEx(DC, Position.X - Left, Position.Y - Top, nil);
    IntersectClipRect(DC, 0, 0, Parent.ClientWidth, Parent.ClientHeight);
    Parent.Perform(WM_ERASEBKGND, DC, 0);
    Parent.Perform(WM_PAINT, DC, 0);
    RestoreDC(DC, SaveIndex);
  end;
end;


//*****************************************************************************

constructor TPDJsillyGroupButton.InternalCreate(PDJSillyRadioGroup: TPDJSillyRadioGroup);
begin
  inherited Create(PDJSillyRadioGroup);
  PDJSillyRadioGroup.FButtons.Add(Self);
  Visible := False;
  Enabled := PDJSillyRadioGroup.Enabled;
  ParentShowHint := False;
  OnClick := PDJSillyRadioGroup.ButtonClick;
  Parent := PDJSillyRadioGroup;
end;

destructor TPDJsillyGroupButton.Destroy;
begin
  TPDJSillyRadioGroup(Owner).FButtons.Remove(Self);
  inherited Destroy;
end;

procedure TPDJsillyGroupButton.CNCommand(var Message: TWMCommand);
begin
  if not FInClick then
  begin
    FInClick := True;
    try
      if ((Message.NotifyCode = BN_CLICKED) or
        (Message.NotifyCode = BN_DOUBLECLICKED)) and
        TPDJSillyRadioGroup(Parent).CanModify then
        inherited;
    except
      Application.HandleException(Self);
    end;
    FInClick := False;
  end;
end;

procedure TPDJsillyGroupButton.ChangeScale(M, D: Integer);
begin
end;

procedure TPDJsillyGroupButton.KeyPress(var Key: Char);
begin
  inherited KeyPress(Key);
  TPDJSillyRadioGroup(Parent).KeyPress(Key);
  if (Key = #8) or (Key = ' ') then
  begin
    if not TPDJSillyRadioGroup(Parent).CanModify then Key := #0;
  end;
end;

procedure TPDJsillyGroupButton.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited KeyDown(Key, Shift);
  TPDJSillyRadioGroup(Parent).KeyDown(Key, Shift);
end;
//******************************************************************************


{ TPDJSillyRadioGroup }

constructor TPDJSillyRadioGroup.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := [csSetCaption, csDoubleClicks];
  FButtons := TList.Create;
  FItems := TStringList.Create;
  TStringList(FItems).OnChange := ItemsChange;
  FItemIndex := -1;
  FColumns := 1;
  FMColorChecked:=clBlue;
  FMColorUnChecked:=clBtnHighlight;
  FMColorLineFocus:=clBlue;
  FMColorLine:=clBtnHighlight;
  FTransparent:=False;
  FMShowHandCursor:=True;
end;

destructor TPDJSillyRadioGroup.Destroy;
begin
  SetButtonCount(0);
  TStringList(FItems).OnChange := nil;
  FItems.Free;
  FButtons.Free;
  inherited Destroy;
end;

procedure TPDJSillyRadioGroup.ArrangeButtons;
var
  ButtonsPerCol, ButtonWidth, ButtonHeight, TopMargin, I: Integer;
  DC: HDC;
  SaveFont: HFont;
  Metrics: TTextMetric;
  DeferHandle: THandle;
begin
  if (FButtons.Count <> 0) and not FReading then
  begin
    DC := GetDC(0);
    SaveFont := SelectObject(DC, Font.Handle);
    GetTextMetrics(DC, Metrics);
    SelectObject(DC, SaveFont);
    ReleaseDC(0, DC);
    ButtonsPerCol := (FButtons.Count + FColumns - 1) div FColumns;
    ButtonWidth := (Width - 20) div FColumns;
    I := Height - Metrics.tmHeight -10;
    ButtonHeight := I div ButtonsPerCol;
    TopMargin := Metrics.tmHeight + 1 + (I mod ButtonsPerCol) div 2;
    DeferHandle := BeginDeferWindowPos(FButtons.Count);
    for I := 0 to FButtons.Count - 1 do
      with TPDJSillyGroupButton(FButtons[I]) do
      begin
        DeferHandle := DeferWindowPos(DeferHandle, Handle, 0,
          (I div ButtonsPerCol) * ButtonWidth + 8,
          (I mod ButtonsPerCol) * ButtonHeight + TopMargin,
          ButtonWidth, ButtonHeight,
          SWP_NOZORDER or SWP_NOACTIVATE);
        Visible := True;
      end;
    EndDeferWindowPos(DeferHandle);
  end;
end;

procedure TPDJSillyRadioGroup.ButtonClick(Sender: TObject);
begin
  if not FUpdating then
  begin
    FItemIndex := FButtons.IndexOf(Sender);
    Changed;
    Click;
  end;
end;

procedure TPDJSillyRadioGroup.ItemsChange(Sender: TObject);
begin
  if not FReading then
  begin
    if FItemIndex >= FItems.Count then FItemIndex := FItems.Count - 1;
    UpdateButtons;
  end;
end;

procedure TPDJSillyRadioGroup.ReadState(Reader: TReader);
begin
  FReading := True;
  inherited ReadState(Reader);
  FReading := False;
  UpdateButtons;
end;

procedure TPDJSillyRadioGroup.SetButtonCount(Value: Integer);
begin
  while FButtons.Count < Value do TPDJSillyGroupButton.InternalCreate(Self);
  while FButtons.Count > Value do TPDJSillyGroupButton(FButtons.Last).Free;
end;

procedure TPDJSillyRadioGroup.SetColumns(Value: Integer);
begin
  if Value < 1 then Value := 1;
  if Value > 16 then Value := 16;
  if FColumns <> Value then
  begin
    FColumns := Value;
    ArrangeButtons;
    Invalidate;
  end;
end;

procedure TPDJSillyRadioGroup.SetItemIndex(Value: Integer);
begin
  if FReading then FItemIndex := Value else
  begin
    if Value < -1 then Value := -1;
    if Value >= FButtons.Count then Value := FButtons.Count - 1;
    if FItemIndex <> Value then
    begin
      if FItemIndex >= 0 then
        TPDJSillyGroupButton(FButtons[FItemIndex]).Checked := False;
      FItemIndex := Value;
      if FItemIndex >= 0 then
        TPDJSillyGroupButton(FButtons[FItemIndex]).Checked := True;
    end;
  end;
end;

procedure TPDJSillyRadioGroup.SetItems(Value: TStrings);
begin
  FItems.Assign(Value);
end;

procedure TPDJSillyRadioGroup.UpdateButtons;
var
  I: Integer;
begin
  SetButtonCount(FItems.Count);
  for I := 0 to FButtons.Count - 1 do
    TPDJSillyGroupButton(FButtons[I]).Caption := FItems[I];
  if FItemIndex >= 0 then
  begin
    FUpdating := True;
    TPDJSillyGroupButton(FButtons[FItemIndex]).Checked := True;
    FUpdating := False;
  end;
  ArrangeButtons;
    for I := 0 to FButtons.Count - 1 do begin
    TPDJSillyGroupButton(FButtons[I]).ColorChecked := FMColorChecked;
    TPDJSillyGroupButton(FButtons[I]).ColorUnChecked := FMColorUnChecked;
    TPDJSillyGroupButton(FButtons[I]).ColorLine := FMColorLine;
    TPDJSillyGroupButton(FButtons[I]).ColorLineFocus := FMColorLineFocus;
    TPDJSillyGroupButton(FButtons[I]).Transparent := FTransparent;
    TPDJSillyGroupButton(FButtons[I]).ShowHandCursor := FMShowHandCursor;
    end;
  Invalidate;
end;

procedure TPDJSillyRadioGroup.CMEnabledChanged(var Message: TMessage);
var
  I: Integer;
begin
  inherited;
  for I := 0 to FButtons.Count - 1 do
    TPDJSillyGroupButton(FButtons[I]).Enabled := Enabled;
end;

procedure TPDJSillyRadioGroup.CMFontChanged(var Message: TMessage);
begin
  inherited;
  ArrangeButtons;
end;

procedure TPDJSillyRadioGroup.WMSize(var Message: TWMSize);
begin
  inherited;
  ArrangeButtons;
end;

function TPDJSillyRadioGroup.CanModify: Boolean;
begin
  Result := True;
end;

procedure TPDJSillyRadioGroup.GetChildren(Proc: TGetChildProc; Root: TComponent);
begin
end;

procedure TPDJSillyRadioGroup.SetColor(index:integer ; Value: TColor);
var
I:integer;
begin
Case index of
1:
if Value<>FMColorChecked then
FMColorChecked:=Value;
2:
if Value<>FMColorUnChecked then
FMColorUnChecked:=Value;
3:
if Value<>FMColorLine then
FMColorLine:=Value;
4:
if Value<>FMColorLineFocus then
FMColorLineFocus:=Value;
end;

    for I := 0 to FButtons.Count - 1 do begin
    TPDJSillyGroupButton(FButtons[I]).ColorChecked := FMColorChecked;
    TPDJSillyGroupButton(FButtons[I]).ColorUnChecked := FMColorUnChecked;
    TPDJSillyGroupButton(FButtons[I]).ColorLine := FMColorLine;
    TPDJSillyGroupButton(FButtons[I]).ColorLineFocus := FMColorLineFocus;
    end;

end;

procedure TPDJSillyRadioGroup.SetTransparent(Value: boolean);
var
I:integer;
begin
inherited;
if value<>FTransparent then
FTransparent:=value;
for I := 0 to FButtons.Count - 1 do
TPDJSillyGroupButton(FButtons[I]).Transparent := FTransparent;
end;

procedure TPDJSillyRadioGroup.SetShowHandCursor(Value: boolean);
begin
if value<>FMShowHandCursor then
FMShowHandCursor:=value;
end;




end.
